import {
  APIRequest,
  APIResponse,
  APIEncoder,
  APIDecoder,
  ParameterUtil
} from '@ucap-webmessenger/api';
import { DeviceType } from '@ucap-webmessenger/core';
import { MessageType } from '../types/message.type';

export interface DelRequest extends APIRequest {
  userSeq: number;
  deviceType: DeviceType;
  tokenKey: string;
  type: MessageType;

  msgList: { msgId: number }[];
}

export interface DelResponse extends APIResponse {
  responseCode: string;
  responseMsg: string;
}

const DelEncodeMap = {};

export const encodeDel: APIEncoder<DelRequest> = (req: DelRequest) => {
  return ParameterUtil.encode(DelEncodeMap, req);
};

export const decodeDel: APIDecoder<DelResponse> = (res: any) => {
  return {
    statusCode: res.StatusCode,
    errorMessage: res.ErrorMessage,

    responseCode: res.responseCode,
    responseMsg: res.responseMsg
  } as DelResponse;
};
