import {
  APIRequest,
  APIResponse,
  APIEncoder,
  APIDecoder,
  ParameterUtil
} from '@ucap-webmessenger/api';
import { DeviceType } from '@ucap-webmessenger/core';

export interface UnreadCountRequest extends APIRequest {
  userSeq: number;
  deviceType: DeviceType;
  tokenKey: string;
}

export interface UnreadCountResponse extends APIResponse {
  responseCode: string;
  responseMsg: string;

  unreadCount: number;
}

const UnreadCountEncodeMap = {};

export const encodeUnreadCount: APIEncoder<UnreadCountRequest> = (
  req: UnreadCountRequest
) => {
  return ParameterUtil.encode(UnreadCountEncodeMap, req);
};

export const decodeUnreadCount: APIDecoder<UnreadCountResponse> = (
  res: any
) => {
  return {
    statusCode: res.StatusCode,
    errorMessage: res.ErrorMessage,

    responseCode: res.responseCode,
    responseMsg: res.responseMsg,
    unreadCount: res.unreadCount
  } as UnreadCountResponse;
};
